-- IPC: Semaphores for EuOS
-- by Jeffrey Fielding (JJProg@cyberbury.net)
sequence k_sems, k_sem_waiting
k_sems = {}
k_sem_waiting = {}
global function k_semAlloc()
	integer index
	index = find(-1,k_sems)
	if index then
		k_sems[index] = 0
		return index
	else
		k_sems = append(k_sems,0)
		k_sem_waiting = append(k_sem_waiting,{})
		return length(k_sems)
	end if
end function
global function k_semGet(integer id)
	if k_sems[id] then
		k_sems[id] -= 1
		return 1
	else
		return 0
	end if
end function
global function k_semCheck(integer id)
	return k_sems[id]
end function
global procedure k_semWait(integer id)
	if k_sems[id] = 0 then
		k_sem_waiting[id] &= k_getPid()
		k_setPriority(k_getPid(),0)
	end if
end procedure
global procedure k_semInc(integer id)
	k_sems[id] += 1
	if length(k_sem_waiting[id]) then
		k_setPriority(k_sem_waiting[id][1],1)
		k_sem_waiting[id] = k_sem_waiting[id][2..length(k_sem_waiting[id])]
	end if
end procedure